searchNodes=[{"ref":"Polyjuice.Util.html","title":"Polyjuice.Util","type":"module","doc":""},{"ref":"Polyjuice.Util.html#escape_localpart/2","title":"Polyjuice.Util.escape_localpart/2","type":"function","doc":"Escape a user ID localpart so that it only uses the allowable character set. The method used is defined in https://matrix.org/docs/spec/appendices#mapping-from-other-character-sets By default, it will escape upper-case letters. If you want upper-case letters to simply be lower-cased, use the fold_case: true option. Examples: iex&gt; Polyjuice.Util.escape_localpart(&quot;abc\\x01 !\\&quot;,-./09:;&lt;=&gt;?@AZ[\\\\]^_`az{|}~á&quot;) &quot;abc=01=20=21=22=2c-./09=3a=3b=3c=3d=3e=3f=40_a_z=5b=5c=5d=5e__=60az=7b=7c=7d=7e=c3=a1&quot; iex&gt; Polyjuice.Util.escape_localpart(&quot;abc\\x01 !\\&quot;,-./09:;&lt;=&gt;?@AZ[\\\\]^_`az{|}~á&quot;, fold_case: true) &quot;abc=01=20=21=22=2c-./09=3a=3b=3c=3d=3e=3f=40az=5b=5c=5d=5e_=60az=7b=7c=7d=7e=c3=a1&quot;"},{"ref":"Polyjuice.Util.html#make_verify_key/2","title":"Polyjuice.Util.make_verify_key/2","type":"function","doc":"Make a verify key of the type given by the key ID. Examples: iex&gt; Polyjuice.Util.make_verify_key(&quot;a4qcdbuJoRwy1ykc7Xhj1wTQroEXHdr04AY2Ds6SPb0&quot;, &quot;ed25519:1&quot;) %Polyjuice.Util.Ed25519.VerifyKey{ key: &lt;&lt;107, 138, 156, 117, 187, 137, 161, 28, 50, 215, 41, 28, 237, 120, 99, 215, 4, 208, 174, 129, 23, 29, 218, 244, 224, 6, 54, 14, 206, 146, 61, 189&gt;&gt;, id: &quot;1&quot; }"},{"ref":"Polyjuice.Util.html#t:event/0","title":"Polyjuice.Util.event/0","type":"type","doc":"Represents a full event, including the event content, sender, event type, etc. Will have (at least) the following fields: &quot;type&quot;, &quot;content&quot;, &quot;sender&quot;, &quot;event_id&quot; (if a room event), and &quot;room_id&quot; (if a room event)."},{"ref":"Polyjuice.Util.html#t:event_content/0","title":"Polyjuice.Util.event_content/0","type":"type","doc":"Represents the content field of an event. Its expected fields depend on the type of event. For example, a m.room.message event should have &quot;msgtype&quot; and &quot;body&quot; fields (though implementations should be prepared to deal with malformed events)."},{"ref":"Polyjuice.Util.ClientError.html","title":"Polyjuice.Util.ClientError","type":"module","doc":"Matrix Client API error mapping to Elixir"},{"ref":"Polyjuice.Util.ClientError.html#deferror/3","title":"Polyjuice.Util.ClientError.deferror/3","type":"macro","doc":"deferror macro is used to define error mappings. example: Defining a mapping to M_FORBIDDEN: &gt; import Polyjuice.Util.ClientError &gt; deferror(MForbidden) &gt; e = MForbidden.new %MForbidden{additional_fields: nil, errcode: &quot;M_FORBIDDEN&quot;, error: nil} &gt; json_encode(e) {:ok, &quot;{&quot;errcode&quot;:&quot;M_FORBIDDEN&quot;}&quot;} Defining a mapping to M_LIMIT_EXCEEDED with default message: &gt; import Polyjuice.Util.ClientError &gt; deferror(MLimitExceeded, &quot;Too many requests&quot;) &gt; e = MLimitExceeded.new %MLimitExceeded{ additional_fields: nil, errcode: &quot;M_LIMIT_EXCEEDED&quot;, error: &quot;Too many requests&quot; } &gt; json_encode(e) {:ok, &quot;{&quot;errcode&quot;:&quot;M_LIMIT_EXCEEDED&quot;,&quot;error&quot;:&quot;Too many requests&quot;}&quot;} Defining a mapping to M_LIMIT_EXCEEDED with additional fields: &gt; import Polyjuice.Util.ClientError &gt; deferror(MLimitExceeded, &quot;Too many requests&quot;) &gt; e = MLimitExceeded.new(nil, retry_after_ms: 2000) %MLimitExceeded{ additional_fields: [retry_after_ms: 2000], errcode: &quot;M_LIMIT_EXCEEDED&quot;, error: &quot;Too many requests&quot; } &gt; json_encode(e) {:ok, &quot;{&quot;errcode&quot;:&quot;M_LIMIT_EXCEEDED&quot;,&quot;error&quot;:&quot;Too many requests&quot;,&quot;retry_after_ms&quot;:2000}&quot;}"},{"ref":"Polyjuice.Util.ClientError.html#json_encode/1","title":"Polyjuice.Util.ClientError.json_encode/1","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientError.html#json_encode!/1","title":"Polyjuice.Util.ClientError.json_encode!/1","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientError.html#json_encode_to_iodata/1","title":"Polyjuice.Util.ClientError.json_encode_to_iodata/1","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientError.html#json_encode_to_iodata!/1","title":"Polyjuice.Util.ClientError.json_encode_to_iodata!/1","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientError.ErrorSpec.html","title":"Polyjuice.Util.ClientError.ErrorSpec","type":"protocol","doc":""},{"ref":"Polyjuice.Util.ClientError.ErrorSpec.html#to_map/1","title":"Polyjuice.Util.ClientError.ErrorSpec.to_map/1","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientError.ErrorSpec.html#t:t/0","title":"Polyjuice.Util.ClientError.ErrorSpec.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.Ed25519.SigningKey.html","title":"Polyjuice.Util.Ed25519.SigningKey","type":"module","doc":""},{"ref":"Polyjuice.Util.Ed25519.SigningKey.html#from_base64/2","title":"Polyjuice.Util.Ed25519.SigningKey.from_base64/2","type":"function","doc":"Create a signing key from the base64 representation."},{"ref":"Polyjuice.Util.Ed25519.SigningKey.html#t:t/0","title":"Polyjuice.Util.Ed25519.SigningKey.t/0","type":"opaque","doc":""},{"ref":"Polyjuice.Util.Ed25519.VerifyKey.html","title":"Polyjuice.Util.Ed25519.VerifyKey","type":"module","doc":""},{"ref":"Polyjuice.Util.Ed25519.VerifyKey.html#from_base64/2","title":"Polyjuice.Util.Ed25519.VerifyKey.from_base64/2","type":"function","doc":"Create a verify key from the base64 representation."},{"ref":"Polyjuice.Util.Ed25519.VerifyKey.html#t:t/0","title":"Polyjuice.Util.Ed25519.VerifyKey.t/0","type":"opaque","doc":""},{"ref":"Polyjuice.Util.Identifiers.html","title":"Polyjuice.Util.Identifiers","type":"behaviour","doc":""},{"ref":"Polyjuice.Util.Identifiers.html#c:new/1","title":"Polyjuice.Util.Identifiers.new/1","type":"callback","doc":""},{"ref":"Polyjuice.Util.Identifiers.html#c:new!/1","title":"Polyjuice.Util.Identifiers.new!/1","type":"callback","doc":""},{"ref":"Polyjuice.Util.Identifiers.html#c:parse/1","title":"Polyjuice.Util.Identifiers.parse/1","type":"callback","doc":""},{"ref":"Polyjuice.Util.Identifiers.html#c:valid?/1","title":"Polyjuice.Util.Identifiers.valid?/1","type":"callback","doc":""},{"ref":"Polyjuice.Util.Identifiers.V0.UserIdentifier.html","title":"Polyjuice.Util.Identifiers.V0.UserIdentifier","type":"module","doc":""},{"ref":"Polyjuice.Util.Identifiers.V0.UserIdentifier.html#fqid/1","title":"Polyjuice.Util.Identifiers.V0.UserIdentifier.fqid/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V0.UserIdentifier.html#generate/1","title":"Polyjuice.Util.Identifiers.V0.UserIdentifier.generate/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V0.UserIdentifier.html#new/2","title":"Polyjuice.Util.Identifiers.V0.UserIdentifier.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V0.UserIdentifier.html#t:t/0","title":"Polyjuice.Util.Identifiers.V0.UserIdentifier.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.EventIdentifier.html","title":"Polyjuice.Util.Identifiers.V1.EventIdentifier","type":"module","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.EventIdentifier.html#fqid/1","title":"Polyjuice.Util.Identifiers.V1.EventIdentifier.fqid/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.EventIdentifier.html#new/2","title":"Polyjuice.Util.Identifiers.V1.EventIdentifier.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.EventIdentifier.html#t:t/0","title":"Polyjuice.Util.Identifiers.V1.EventIdentifier.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.RoomAliasIdentifier.html","title":"Polyjuice.Util.Identifiers.V1.RoomAliasIdentifier","type":"module","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.RoomAliasIdentifier.html#fqid/1","title":"Polyjuice.Util.Identifiers.V1.RoomAliasIdentifier.fqid/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.RoomAliasIdentifier.html#new/2","title":"Polyjuice.Util.Identifiers.V1.RoomAliasIdentifier.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.RoomAliasIdentifier.html#t:t/0","title":"Polyjuice.Util.Identifiers.V1.RoomAliasIdentifier.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.RoomIdentifier.html","title":"Polyjuice.Util.Identifiers.V1.RoomIdentifier","type":"module","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.RoomIdentifier.html#fqid/1","title":"Polyjuice.Util.Identifiers.V1.RoomIdentifier.fqid/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.RoomIdentifier.html#generate/1","title":"Polyjuice.Util.Identifiers.V1.RoomIdentifier.generate/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.RoomIdentifier.html#new/2","title":"Polyjuice.Util.Identifiers.V1.RoomIdentifier.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.RoomIdentifier.html#t:t/0","title":"Polyjuice.Util.Identifiers.V1.RoomIdentifier.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.UserIdentifier.html","title":"Polyjuice.Util.Identifiers.V1.UserIdentifier","type":"module","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.UserIdentifier.html#fqid/1","title":"Polyjuice.Util.Identifiers.V1.UserIdentifier.fqid/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.UserIdentifier.html#generate/1","title":"Polyjuice.Util.Identifiers.V1.UserIdentifier.generate/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.UserIdentifier.html#new/2","title":"Polyjuice.Util.Identifiers.V1.UserIdentifier.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V1.UserIdentifier.html#t:t/0","title":"Polyjuice.Util.Identifiers.V1.UserIdentifier.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.Identifiers.V3.EventIdentifier.html","title":"Polyjuice.Util.Identifiers.V3.EventIdentifier","type":"module","doc":""},{"ref":"Polyjuice.Util.Identifiers.V3.EventIdentifier.html#fqid/1","title":"Polyjuice.Util.Identifiers.V3.EventIdentifier.fqid/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Identifiers.V3.EventIdentifier.html#t:t/0","title":"Polyjuice.Util.Identifiers.V3.EventIdentifier.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.JSON.html","title":"Polyjuice.Util.JSON","type":"module","doc":"JSON-related functions."},{"ref":"Polyjuice.Util.JSON.html#canonical_json/1","title":"Polyjuice.Util.JSON.canonical_json/1","type":"function","doc":"Encode a value as canonical JSON. See https://matrix.org/docs/spec/appendices#canonical-json for more information about canonical JSON. Examples: iex&gt; Polyjuice.Util.JSON.canonical_json(%{&quot;a&quot; =&gt; true, &quot;b&quot; =&gt; false, &quot;c&quot; =&gt; nil, &quot;d&quot; =&gt; 42, &quot;e&quot; =&gt; [], &quot;f&quot; =&gt; %{}}) {:ok, &quot;{\\&quot;a\\&quot;:true,\\&quot;b\\&quot;:false,\\&quot;c\\&quot;:null,\\&quot;d\\&quot;:42,\\&quot;e\\&quot;:[],\\&quot;f\\&quot;:{}}&quot;} iex&gt; Polyjuice.Util.JSON.canonical_json(%{&quot;本&quot;=&gt;2,&quot;日&quot;=&gt;1}) {:ok, &quot;{\\&quot;日\\&quot;:1,\\&quot;本\\&quot;:2}&quot;} iex&gt; Polyjuice.Util.JSON.canonical_json(&quot;a日\\t\\&quot;\\\\\\x01\\x0f\\x10\\x1f&quot;) {:ok, &quot;\\&quot;a日\\\\t\\\\\\&quot;\\\\\\\\\\\\u0001\\\\u000F\\\\u0010\\\\u001F\\&quot;&quot;} iex&gt; Polyjuice.Util.JSON.canonical_json([1,2,3,4]) {:ok, &quot;[1,2,3,4]&quot;} Unknown or invalid values will cause an error iex&gt; Polyjuice.Util.JSON.canonical_json([{}]) :error iex&gt; Polyjuice.Util.JSON.canonical_json([:foo]) :error iex&gt; Polyjuice.Util.JSON.canonical_json([0x40000000000000]) :error iex&gt; Polyjuice.Util.JSON.canonical_json([1.1]) :error"},{"ref":"Polyjuice.Util.JSON.html#sign/3","title":"Polyjuice.Util.JSON.sign/3","type":"function","doc":"Sign a JSON object. See https://matrix.org/docs/spec/appendices#signing-json for more information about signing JSON. Examples: iex&gt; Polyjuice.Util.JSON.sign( ...&gt; %{}, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.SigningKey.from_base64(&quot;YJDBA9Xnr2sVqXD9Vj7XVUnmFZcZrlw8Md7kMW+3XA1&quot;, &quot;1&quot;) ...&gt; ) { :ok, %{ &quot;signatures&quot; =&gt; %{ &quot;domain&quot; =&gt; %{ &quot;ed25519:1&quot; =&gt; &quot;K8280/U9SSy9IVtjBuVeLr+HpOB4BQFWbg+UZaADMtTdGYI7Geitb76LTrr5QV/7Xg4ahLwYGYZzuHGZKM5ZAQ&quot; } } } } iex&gt; Polyjuice.Util.JSON.sign( ...&gt; %{&quot;one&quot; =&gt; 1, &quot;two&quot; =&gt; &quot;Two&quot;}, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.SigningKey.from_base64(&quot;YJDBA9Xnr2sVqXD9Vj7XVUnmFZcZrlw8Md7kMW+3XA1&quot;, &quot;1&quot;) ...&gt; ) { :ok, %{ &quot;one&quot; =&gt; 1, &quot;signatures&quot; =&gt; %{ &quot;domain&quot; =&gt; %{ &quot;ed25519:1&quot; =&gt; &quot;KqmLSbO39/Bzb0QIYE82zqLwsA+PDzYIpIRA2sRQ4sL53+sN6/fpNSoqE7BP7vBZhG6kYdD13EIMJpvhJI+6Bw&quot; } }, &quot;two&quot; =&gt; &quot;Two&quot; } }"},{"ref":"Polyjuice.Util.JSON.html#signed?/3","title":"Polyjuice.Util.JSON.signed?/3","type":"function","doc":"Verify a signed JSON object. See https://matrix.org/docs/spec/appendices#signing-json for more information about signing JSON. Examples: iex&gt; Polyjuice.Util.JSON.signed?( ...&gt; %{ ...&gt; &quot;signatures&quot; =&gt; %{ ...&gt; &quot;domain&quot; =&gt; %{ ...&gt; &quot;ed25519:1&quot; =&gt; &quot;K8280/U9SSy9IVtjBuVeLr+HpOB4BQFWbg+UZaADMtTdGYI7Geitb76LTrr5QV/7Xg4ahLwYGYZzuHGZKM5ZAQ&quot; ...&gt; } ...&gt; } ...&gt; }, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.VerifyKey.from_base64(&quot;XGX0JRS2Af3be3knz2fBiRbApjm2Dh61gXDJA8kcJNI&quot;, &quot;1&quot;) ...&gt; ) true iex&gt; Polyjuice.Util.JSON.signed?( ...&gt; %{ ...&gt; &quot;one&quot; =&gt; 1, ...&gt; &quot;signatures&quot; =&gt; %{ ...&gt; &quot;domain&quot; =&gt; %{ ...&gt; &quot;ed25519:1&quot; =&gt; &quot;KqmLSbO39/Bzb0QIYE82zqLwsA+PDzYIpIRA2sRQ4sL53+sN6/fpNSoqE7BP7vBZhG6kYdD13EIMJpvhJI+6Bw&quot; ...&gt; } ...&gt; }, ...&gt; &quot;two&quot; =&gt; &quot;Two&quot; ...&gt; }, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.VerifyKey.from_base64(&quot;XGX0JRS2Af3be3knz2fBiRbApjm2Dh61gXDJA8kcJNI&quot;, &quot;1&quot;) ...&gt; ) true Missing signature: iex&gt; Polyjuice.Util.JSON.signed?( ...&gt; %{ ...&gt; &quot;signatures&quot; =&gt; %{ ...&gt; &quot;domain&quot; =&gt; %{ ...&gt; &quot;ed25519:2&quot; =&gt; &quot;K8280/U9SSy9IVtjBuVeLr+HpOB4BQFWbg+UZaADMtTdGYI7Geitb76LTrr5QV/7Xg4ahLwYGYZzuHGZKM5ZAQ&quot; ...&gt; } ...&gt; } ...&gt; }, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.VerifyKey.from_base64(&quot;XGX0JRS2Af3be3knz2fBiRbApjm2Dh61gXDJA8kcJNI&quot;, &quot;1&quot;) ...&gt; ) false Incorrect signature: iex&gt; Polyjuice.Util.JSON.signed?( ...&gt; %{ ...&gt; &quot;signatures&quot; =&gt; %{ ...&gt; &quot;domain&quot; =&gt; %{ ...&gt; &quot;ed25519:1&quot; =&gt; &quot;00000000000000000000000000000000000000000000000000000000000000000000000000000000000000&quot; ...&gt; } ...&gt; } ...&gt; }, ...&gt; &quot;domain&quot;, ...&gt; Polyjuice.Util.Ed25519.VerifyKey.from_base64(&quot;XGX0JRS2Af3be3knz2fBiRbApjm2Dh61gXDJA8kcJNI&quot;, &quot;1&quot;) ...&gt; ) false"},{"ref":"Polyjuice.Util.JSON.html#verify/3","title":"Polyjuice.Util.JSON.verify/3","type":"function","doc":""},{"ref":"Polyjuice.Util.Randomizer.html","title":"Polyjuice.Util.Randomizer","type":"module","doc":"Random string generator module."},{"ref":"Polyjuice.Util.Randomizer.html#crypto_random_string/1","title":"Polyjuice.Util.Randomizer.crypto_random_string/1","type":"function","doc":""},{"ref":"Polyjuice.Util.Randomizer.html#randomize/2","title":"Polyjuice.Util.Randomizer.randomize/2","type":"function","doc":"Generate random string based on the given length. It is also possible to generate certain type of randomise string using the options below: :all - generate alphanumeric random string :alpha - generate nom-numeric random string :numeric - generate numeric random string :upcase - generate upper case non-numeric random string :downcase - generate lower case non-numeric random string :upcase_numeric - generate uppercase alphanumeric random string :downcase_numeric - generate downcase alphanumeric random string Example iex&gt; Randomizer.randomizer(20) //&quot;Je5QaLj982f0Meb0ZBSK&quot;"},{"ref":"Polyjuice.Util.Randomizer.html#unique_id/0","title":"Polyjuice.Util.Randomizer.unique_id/0","type":"function","doc":""},{"ref":"Polyjuice.Util.RoomVersion.html","title":"Polyjuice.Util.RoomVersion","type":"module","doc":"Functions related to room versions."},{"ref":"Polyjuice.Util.RoomVersion.html#authorized?/4","title":"Polyjuice.Util.RoomVersion.authorized?/4","type":"function","doc":"Determine if an event is allowed to be sent to a room, given the room state. Example: iex&gt; Polyjuice.Util.RoomVersion.authorized?( ...&gt; &quot;1&quot;, ...&gt; %{ ...&gt; &quot;sender&quot; =&gt; &quot;@u:domain&quot;, ...&gt; &quot;type&quot; =&gt; &quot;m.room.create&quot;, ...&gt; &quot;room_id&quot; =&gt; &quot;!foo:domain&quot;, ...&gt; &quot;content&quot; =&gt; %{ ...&gt; &quot;creator&quot; =&gt; &quot;@u:domain&quot;, ...&gt; } ...&gt; }, ...&gt; %{} ...&gt; ) true"},{"ref":"Polyjuice.Util.RoomVersion.html#compute_content_hash/2","title":"Polyjuice.Util.RoomVersion.compute_content_hash/2","type":"function","doc":"Compute the content hash for an event."},{"ref":"Polyjuice.Util.RoomVersion.html#compute_reference_hash/2","title":"Polyjuice.Util.RoomVersion.compute_reference_hash/2","type":"function","doc":"Compute the reference hash for an event."},{"ref":"Polyjuice.Util.RoomVersion.html#get_required_pl/4","title":"Polyjuice.Util.RoomVersion.get_required_pl/4","type":"function","doc":"Get the required power level for sending an event. event_type is either a string indicating one of the keys at the top level of the m.room.power_levels event (ban, invite, kick, redact), or a list indicating the path within the m.room.power_levels event to check (e.g. [&quot;events&quot;, &quot;m.room.topic&quot;] or [&quot;notifications&quot;, &quot;room&quot;]). Examples: iex&gt; Polyjuice.Util.RoomVersion.get_required_pl( ...&gt; &quot;1&quot;, ...&gt; [&quot;events&quot;, &quot;m.room.message&quot;], ...&gt; false, ...&gt; %{ ...&gt; {&quot;m.room.power_levels&quot;, &quot;&quot;} =&gt; %{ ...&gt; &quot;type&quot; =&gt; &quot;m.room.power_levels&quot;, ...&gt; &quot;state_key&quot; =&gt; &quot;&quot;, ...&gt; &quot;sender&quot; =&gt; &quot;@alice:example.org&quot;, ...&gt; &quot;content&quot; =&gt; %{ ...&gt; &quot;events&quot; =&gt; %{ ...&gt; &quot;m.room.topic&quot; =&gt; 75 ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; ) {:ok, 0} iex&gt; Polyjuice.Util.RoomVersion.get_required_pl( ...&gt; &quot;1&quot;, ...&gt; [&quot;events&quot;, &quot;m.room.name&quot;], ...&gt; true, ...&gt; %{ ...&gt; {&quot;m.room.power_levels&quot;, &quot;&quot;} =&gt; %{ ...&gt; &quot;type&quot; =&gt; &quot;m.room.power_levels&quot;, ...&gt; &quot;state_key&quot; =&gt; &quot;&quot;, ...&gt; &quot;sender&quot; =&gt; &quot;@alice:example.org&quot;, ...&gt; &quot;content&quot; =&gt; %{ ...&gt; &quot;events&quot; =&gt; %{ ...&gt; &quot;m.room.topic&quot; =&gt; 75 ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; ) {:ok, 50} iex&gt; Polyjuice.Util.RoomVersion.get_required_pl( ...&gt; &quot;1&quot;, ...&gt; [&quot;events&quot;, &quot;m.room.topic&quot;], ...&gt; true, ...&gt; %{ ...&gt; {&quot;m.room.power_levels&quot;, &quot;&quot;} =&gt; %{ ...&gt; &quot;type&quot; =&gt; &quot;m.room.power_levels&quot;, ...&gt; &quot;state_key&quot; =&gt; &quot;&quot;, ...&gt; &quot;sender&quot; =&gt; &quot;@alice:example.org&quot;, ...&gt; &quot;content&quot; =&gt; %{ ...&gt; &quot;events&quot; =&gt; %{ ...&gt; &quot;m.room.topic&quot; =&gt; 75 ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; ) {:ok, 75}"},{"ref":"Polyjuice.Util.RoomVersion.html#get_room_version/1","title":"Polyjuice.Util.RoomVersion.get_room_version/1","type":"function","doc":"Get the room version from an m.room.create event. Examples: iex&gt; Polyjuice.Util.RoomVersion.get_room_version(%{ ...&gt; &quot;type&quot; =&gt; &quot;m.room.create&quot;, ...&gt; &quot;sender&quot; =&gt; &quot;@alice:example.org&quot;, ...&gt; &quot;content&quot; =&gt; %{ ...&gt; &quot;room_version&quot; =&gt; &quot;2&quot; ...&gt; } ...&gt; }) &quot;2&quot;"},{"ref":"Polyjuice.Util.RoomVersion.html#get_user_pl/3","title":"Polyjuice.Util.RoomVersion.get_user_pl/3","type":"function","doc":"Get the user&#39;s power level, given the room state. Examples: iex&gt; Polyjuice.Util.RoomVersion.get_user_pl( ...&gt; &quot;1&quot;, ...&gt; &quot;@alice:example.org&quot;, ...&gt; %{ ...&gt; {&quot;m.room.power_levels&quot;, &quot;&quot;} =&gt; %{ ...&gt; &quot;type&quot; =&gt; &quot;m.room.power_levels&quot;, ...&gt; &quot;state_key&quot; =&gt; &quot;&quot;, ...&gt; &quot;sender&quot; =&gt; &quot;@alice:example.org&quot;, ...&gt; &quot;content&quot; =&gt; %{ ...&gt; &quot;users&quot; =&gt; %{ ...&gt; &quot;@alice:example.org&quot; =&gt; 75 ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; ) {:ok, 75} iex&gt; Polyjuice.Util.RoomVersion.get_user_pl( ...&gt; &quot;1&quot;, ...&gt; &quot;@bob:example.org&quot;, ...&gt; %{ ...&gt; {&quot;m.room.power_levels&quot;, &quot;&quot;} =&gt; %{ ...&gt; &quot;type&quot; =&gt; &quot;m.room.power_levels&quot;, ...&gt; &quot;state_key&quot; =&gt; &quot;&quot;, ...&gt; &quot;sender&quot; =&gt; &quot;@alice:example.org&quot;, ...&gt; &quot;content&quot; =&gt; %{ ...&gt; &quot;users&quot; =&gt; %{ ...&gt; &quot;@alice:example.org&quot; =&gt; 75 ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; ) {:ok, 0}"},{"ref":"Polyjuice.Util.RoomVersion.html#redact/2","title":"Polyjuice.Util.RoomVersion.redact/2","type":"function","doc":"Calculate the redacted version of an event for the given room version. Examples: iex&gt; Polyjuice.Util.RoomVersion.redact( ...&gt; &quot;1&quot;, ...&gt; %{ ...&gt; &quot;content&quot; =&gt; %{ ...&gt; &quot;body&quot; =&gt; &quot;Here is the message content&quot; ...&gt; }, ...&gt; &quot;event_id&quot; =&gt; &quot;$0:domain&quot;, ...&gt; &quot;origin&quot; =&gt; &quot;domain&quot;, ...&gt; &quot;origin_server_ts&quot; =&gt; 1000000, ...&gt; &quot;type&quot; =&gt; &quot;m.room.message&quot;, ...&gt; &quot;room_id&quot; =&gt; &quot;!r:domain&quot;, ...&gt; &quot;sender&quot; =&gt; &quot;@u:domain&quot;, ...&gt; &quot;signatures&quot; =&gt; %{}, ...&gt; &quot;unsigned&quot; =&gt; %{ ...&gt; &quot;age_ts&quot; =&gt; 1000000 ...&gt; } ...&gt; } ...&gt; ) { :ok, %{ &quot;content&quot; =&gt; %{}, &quot;event_id&quot; =&gt; &quot;$0:domain&quot;, &quot;origin&quot; =&gt; &quot;domain&quot;, &quot;origin_server_ts&quot; =&gt; 1000000, &quot;type&quot; =&gt; &quot;m.room.message&quot;, &quot;room_id&quot; =&gt; &quot;!r:domain&quot;, &quot;sender&quot; =&gt; &quot;@u:domain&quot;, &quot;signatures&quot; =&gt; %{} } } iex&gt; Polyjuice.Util.RoomVersion.redact( ...&gt; &quot;unknown room version&quot;, ...&gt; %{} ...&gt; ) :error"},{"ref":"Polyjuice.Util.RoomVersion.html#t:state/0","title":"Polyjuice.Util.RoomVersion.state/0","type":"type","doc":"The state of a room. A map from {event_type, state_key} to state event."},{"ref":"Polyjuice.Util.SigningKey.html","title":"Polyjuice.Util.SigningKey","type":"protocol","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#algorithm/1","title":"Polyjuice.Util.SigningKey.algorithm/1","type":"function","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#id/1","title":"Polyjuice.Util.SigningKey.id/1","type":"function","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#sign/2","title":"Polyjuice.Util.SigningKey.sign/2","type":"function","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#version/1","title":"Polyjuice.Util.SigningKey.version/1","type":"function","doc":""},{"ref":"Polyjuice.Util.SigningKey.html#t:t/0","title":"Polyjuice.Util.SigningKey.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.URI.html","title":"Polyjuice.Util.URI","type":"module","doc":""},{"ref":"Polyjuice.Util.URI.html#__struct__/0","title":"Polyjuice.Util.URI.__struct__/0","type":"function","doc":"Functions for using Matrix URIs Supports matrix.to, matrix:, and mxc: URIs, and supports referencing users, rooms (by ID or alias), events (using room ID or room alias), and media (mxc: URIs only)."},{"ref":"Polyjuice.Util.URI.html#parse/1","title":"Polyjuice.Util.URI.parse/1","type":"function","doc":"Parse a Matrix URI. Examples iex&gt; Polyjuice.Util.URI.parse(&quot;matrix:u/hubert:uhoreg.ca&quot;) {:ok, %Polyjuice.Util.URI{ type: :user, identifier: &quot;@hubert:uhoreg.ca&quot;, query_params: [] }} iex&gt; Polyjuice.Util.URI.parse(&quot;https://matrix.to/#/%40hubert:uhoreg.ca&quot;) {:ok, %Polyjuice.Util.URI{ type: :user, identifier: &quot;@hubert:uhoreg.ca&quot;, query_params: [] }}"},{"ref":"Polyjuice.Util.URI.html#parse/2","title":"Polyjuice.Util.URI.parse/2","type":"function","doc":""},{"ref":"Polyjuice.Util.URI.html#to_string/2","title":"Polyjuice.Util.URI.to_string/2","type":"function","doc":"Generate a Matrix URI. format indicates what URI format to generate. Currently, it defaults to matrix_to; in the future when the matrix format is supported by more clients, the default may change to that. If you require a certain format, you should specify it rather than relying on the default behaviour. :media URIs will always be mxc: URIs, regardless of the format. Examples iex&gt; Polyjuice.Util.URI.to_string( ...&gt; %Polyjuice.Util.URI{type: :user, identifier: &quot;@hubert:uhoreg.ca&quot;}, ...&gt; :matrix ...&gt; ) &quot;matrix:u/hubert%3Auhoreg.ca&quot; iex&gt; Polyjuice.Util.URI.to_string( ...&gt; %Polyjuice.Util.URI{type: :user, identifier: &quot;@hubert:uhoreg.ca&quot;}, ...&gt; :matrix_to ...&gt; ) &quot;https://matrix.to/#/%40hubert%3Auhoreg.ca&quot;"},{"ref":"Polyjuice.Util.URI.html#t:t/0","title":"Polyjuice.Util.URI.t/0","type":"type","doc":"For users, room IDs and room aliases, identifier is a string. For events, it is of the form {room_id_or_alias, event_id}. And for media, it is of the form {server, id}."},{"ref":"Polyjuice.Util.VerifyKey.html","title":"Polyjuice.Util.VerifyKey","type":"protocol","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#algorithm/1","title":"Polyjuice.Util.VerifyKey.algorithm/1","type":"function","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#id/1","title":"Polyjuice.Util.VerifyKey.id/1","type":"function","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#verify/3","title":"Polyjuice.Util.VerifyKey.verify/3","type":"function","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#version/1","title":"Polyjuice.Util.VerifyKey.version/1","type":"function","doc":""},{"ref":"Polyjuice.Util.VerifyKey.html#t:t/0","title":"Polyjuice.Util.VerifyKey.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.html","title":"Polyjuice.Util.ClientAPIErrors","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MBadJson.html","title":"Polyjuice.Util.ClientAPIErrors.MBadJson","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MBadJson.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MBadJson.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MBadJson.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MBadJson.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MBadState.html","title":"Polyjuice.Util.ClientAPIErrors.MBadState","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MBadState.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MBadState.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MBadState.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MBadState.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MCannotLeaveServerNoticeRoom.html","title":"Polyjuice.Util.ClientAPIErrors.MCannotLeaveServerNoticeRoom","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MCannotLeaveServerNoticeRoom.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MCannotLeaveServerNoticeRoom.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MCannotLeaveServerNoticeRoom.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MCannotLeaveServerNoticeRoom.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MCaptchaInvalid.html","title":"Polyjuice.Util.ClientAPIErrors.MCaptchaInvalid","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MCaptchaInvalid.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MCaptchaInvalid.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MCaptchaInvalid.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MCaptchaInvalid.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MCaptchaNeeded.html","title":"Polyjuice.Util.ClientAPIErrors.MCaptchaNeeded","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MCaptchaNeeded.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MCaptchaNeeded.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MCaptchaNeeded.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MCaptchaNeeded.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MExclusive.html","title":"Polyjuice.Util.ClientAPIErrors.MExclusive","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MExclusive.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MExclusive.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MExclusive.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MExclusive.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MForbidden.html","title":"Polyjuice.Util.ClientAPIErrors.MForbidden","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MForbidden.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MForbidden.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MForbidden.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MForbidden.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MGuestAccessForbidden.html","title":"Polyjuice.Util.ClientAPIErrors.MGuestAccessForbidden","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MGuestAccessForbidden.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MGuestAccessForbidden.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MGuestAccessForbidden.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MGuestAccessForbidden.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MIncompatibleRoomVersion.html","title":"Polyjuice.Util.ClientAPIErrors.MIncompatibleRoomVersion","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MIncompatibleRoomVersion.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MIncompatibleRoomVersion.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MIncompatibleRoomVersion.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MIncompatibleRoomVersion.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MInvalidParam.html","title":"Polyjuice.Util.ClientAPIErrors.MInvalidParam","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MInvalidParam.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MInvalidParam.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MInvalidParam.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MInvalidParam.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MInvalidRoomState.html","title":"Polyjuice.Util.ClientAPIErrors.MInvalidRoomState","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MInvalidRoomState.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MInvalidRoomState.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MInvalidRoomState.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MInvalidRoomState.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MInvalidUsername.html","title":"Polyjuice.Util.ClientAPIErrors.MInvalidUsername","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MInvalidUsername.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MInvalidUsername.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MInvalidUsername.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MInvalidUsername.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MLimitExceeded.html","title":"Polyjuice.Util.ClientAPIErrors.MLimitExceeded","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MLimitExceeded.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MLimitExceeded.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MLimitExceeded.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MLimitExceeded.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MMissingParam.html","title":"Polyjuice.Util.ClientAPIErrors.MMissingParam","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MMissingParam.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MMissingParam.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MMissingParam.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MMissingParam.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MMissingToken.html","title":"Polyjuice.Util.ClientAPIErrors.MMissingToken","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MMissingToken.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MMissingToken.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MMissingToken.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MMissingToken.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MNotFound.html","title":"Polyjuice.Util.ClientAPIErrors.MNotFound","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MNotFound.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MNotFound.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MNotFound.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MNotFound.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MNotJson.html","title":"Polyjuice.Util.ClientAPIErrors.MNotJson","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MNotJson.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MNotJson.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MNotJson.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MNotJson.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MResourceLimitExceeded.html","title":"Polyjuice.Util.ClientAPIErrors.MResourceLimitExceeded","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MResourceLimitExceeded.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MResourceLimitExceeded.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MResourceLimitExceeded.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MResourceLimitExceeded.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MRoomInUse.html","title":"Polyjuice.Util.ClientAPIErrors.MRoomInUse","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MRoomInUse.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MRoomInUse.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MRoomInUse.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MRoomInUse.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MServerNotTrusted.html","title":"Polyjuice.Util.ClientAPIErrors.MServerNotTrusted","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MServerNotTrusted.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MServerNotTrusted.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MServerNotTrusted.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MServerNotTrusted.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidAuthFailed.html","title":"Polyjuice.Util.ClientAPIErrors.MThreepidAuthFailed","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidAuthFailed.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MThreepidAuthFailed.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidAuthFailed.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MThreepidAuthFailed.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidDenied.html","title":"Polyjuice.Util.ClientAPIErrors.MThreepidDenied","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidDenied.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MThreepidDenied.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidDenied.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MThreepidDenied.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidInUse.html","title":"Polyjuice.Util.ClientAPIErrors.MThreepidInUse","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidInUse.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MThreepidInUse.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidInUse.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MThreepidInUse.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidNotFound.html","title":"Polyjuice.Util.ClientAPIErrors.MThreepidNotFound","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidNotFound.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MThreepidNotFound.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MThreepidNotFound.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MThreepidNotFound.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MTooLarge.html","title":"Polyjuice.Util.ClientAPIErrors.MTooLarge","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MTooLarge.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MTooLarge.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MTooLarge.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MTooLarge.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnauthorized.html","title":"Polyjuice.Util.ClientAPIErrors.MUnauthorized","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnauthorized.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MUnauthorized.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnauthorized.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MUnauthorized.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnknown.html","title":"Polyjuice.Util.ClientAPIErrors.MUnknown","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnknown.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MUnknown.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnknown.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MUnknown.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnknownToken.html","title":"Polyjuice.Util.ClientAPIErrors.MUnknownToken","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnknownToken.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MUnknownToken.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnknownToken.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MUnknownToken.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnrecognized.html","title":"Polyjuice.Util.ClientAPIErrors.MUnrecognized","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnrecognized.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MUnrecognized.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnrecognized.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MUnrecognized.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnsupportedRoomVersion.html","title":"Polyjuice.Util.ClientAPIErrors.MUnsupportedRoomVersion","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnsupportedRoomVersion.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MUnsupportedRoomVersion.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUnsupportedRoomVersion.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MUnsupportedRoomVersion.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUserDeactivated.html","title":"Polyjuice.Util.ClientAPIErrors.MUserDeactivated","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUserDeactivated.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MUserDeactivated.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUserDeactivated.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MUserDeactivated.t/0","type":"type","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUserInUse.html","title":"Polyjuice.Util.ClientAPIErrors.MUserInUse","type":"module","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUserInUse.html#new/2","title":"Polyjuice.Util.ClientAPIErrors.MUserInUse.new/2","type":"function","doc":""},{"ref":"Polyjuice.Util.ClientAPIErrors.MUserInUse.html#t:t/0","title":"Polyjuice.Util.ClientAPIErrors.MUserInUse.t/0","type":"type","doc":""},{"ref":"readme.html","title":"Polyjuice Util","type":"extras","doc":"Polyjuice Util Utility functions for using the Matrix protocol. These are functions that are used by multiple components (e.g. clients, application services, identity services, homeservers)."},{"ref":"readme.html#installation","title":"Polyjuice Util - Installation","type":"extras","doc":"The package can be installed by adding polyjuice_util to your list of dependencies in mix.exs: def deps do [ {:polyjuice_util, &quot;~&gt; 0.2.2&quot;} ] end SPDX-License-Identifier: CC0-1.0 -->"}]